﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Infragistics.Controls.Menus;
using Infragistics.Windows;

namespace xamMenuFun
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool _buttonClicked = false;
        private XamMenuItem _lastClicked = null;

        public MainWindow()
        {
            InitializeComponent();            
        }

        private void xamNavigator_ItemClicked(object sender, Infragistics.Controls.Menus.ItemClickedEventArgs e)
        {
            //XamMenuItem mi = e.Item;
            //mi.IsSubmenuOpen = false;
            GroupPanelData item = e.Item.Header as GroupPanelData;
            
            MessageBox.Show("Item clicked: " + item.Title);
        }

        private void NavigatorItemLabel_Loaded(object sender, RoutedEventArgs e)
        {
            XamMenuItem xmi = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(XamMenuItem), true) as XamMenuItem;

            // Set tooltip
            TextBlock textBlock = sender as TextBlock;
            ToolTipService.SetInitialShowDelay(textBlock, 1000);            
            textBlock.ToolTip = textBlock.Text;

            // Wire events -- click means navigate to group panel, SubmenuOpened is to keep drop down from happening
            xmi.Click += new EventHandler(xmi_Click);
            xmi.SubmenuOpened +=new EventHandler(xmi_SubmenuOpened);
            

        }

        void xmi_Click(object sender, EventArgs e)
        {
            XamMenuItem mi = sender as XamMenuItem;

            // Only if we've clicked something new
            if (_lastClicked == null || (_lastClicked != null && _lastClicked != mi))
            {
                // Need to decorate the clicked menu item to indicate it is active
                // Not sure how to do this in xaml???                
                mi.FontWeight = System.Windows.FontWeights.Bold;

                if (_lastClicked != null)
                {
                    // Reset prior selection
                    _lastClicked.FontWeight = System.Windows.FontWeights.Normal;
                }

                _lastClicked = mi;

                // Scroll to correct spot
                MessageBox.Show("Click!");
            }
        }

        void xmi_SubmenuOpened(object sender, EventArgs e)
        {            
            XamMenuItem mi = sender as XamMenuItem;
            if (mi.HasChildren && !_buttonClicked)
            {                
                mi.IsSubmenuOpen = false;
                xmi_Click(sender, e);
            }

            // Reset the button flag if it was true this go around
            if (_buttonClicked)
            {
                _buttonClicked = false;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            // Need a way to keep the xmi_SubmenuOpened event from processing
            // This is klugey way for now.
            _buttonClicked = true;

            // Drop down submenu
            XamMenuItem xmi = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(XamMenuItem), true) as XamMenuItem;
            
            if (xmi.HasChildren)
            {
                xmi.IsSubmenuOpen = true;
            }
        }

        private void NavigatorSubitem_Loaded(object sender, RoutedEventArgs e)
        {
            XamMenuItem xmi = Utilities.GetAncestorFromType(sender as DependencyObject, typeof(XamMenuItem), true) as XamMenuItem;

            // Set tooltip
            TextBlock textBlock = sender as TextBlock;
            ToolTipService.SetInitialShowDelay(textBlock, 1000);
            textBlock.ToolTip = textBlock.Text;

            // Wire events -- click means navigate to group panel, SubmenuOpened is to keep drop down from happening
            xmi.Click += new EventHandler(xmi_Click);
        }
    }
}
